/********************************************************************************/
/* Copyright (c) 2007, SAS Institute Inc., Cary, NC, USA.  All rights reserved. */
/* NAME:        'BUILD_EDIT_ENGINE'                                             */
/*                                                                              */
/* DATE:        13OCT04                                                         */
/* PRODUCT:     SAS Fair Banking                                                */
/* PURPOSE:     regenerate %include statments that execute edits                */
/*                                                                              */
/* USAGE:       %build_edit_engine ;                                            */
/*                                                                              */
/* PARAMETERS:  I|O|U - comments                                                */
/* DOCUMENT:                                                                    */
/* TEST PROGRAM:                                                                */
/* NOTES:       called by webapp UI under edit registration                     */
/* END                                                                          */
/********************************************************************************/
                                                                                                                                                                           
                                                                                                                                                                                                                                                                
%macro build_edit_engine / des='Rebuild edits engine';                                                                                                                                                                                                   


   %put NOTE: {START: BUILD_EDIT_ENGINE};
                                                                                                                                                                                                                                                                
   %macro generateEditCode (HMDA_or_CRA , editsds) ;                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                
      %if &HMDA_or_CRA = HMDA %then 
      %do ;                                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA Transmittal Edits during the final edit check * ;                                                                                                                                                                  
      *before the submission file is generated                                             * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                        /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                        record_1_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode year_condition statement $200 ;    
                
                  file "&jobpath/final_hmda_transmittal_edits.sas" ;                                                                                                                                                                                            
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds ; ' ;                                                                                                                                                                                                                          
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                  end ;  
                  
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                     
                                    
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;                                                                                                                                                                                                                                                                      
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
               put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA LAR Edits during the final edit check         * ;                                                                                                                                                                  
      *before the submission file is generated                                             * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                        /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                        record_2_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_hmda_lar_edits.sas" ;                                                                                                                                                                                                    
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                     
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
               put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA Transmittal Edits during interaction via the  * ;                                                                                                                                                                  
      *HMDA Submission UI                                                                  * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                               
                                       active_ind="1" and                                                                                                                                                                                                         
                                       final_chk_only_ind="0" and                                                                                                                                                                                     
                                       geo_edit_ind="0" and                                                                                                                                                                                                           
                                       record_1_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/hmda_transmittal_edits.sas" ;                                                                                                                                                                                                  
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                     
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                             
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
               put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA LAR Edits during any of the SAS/WA load/update* ;                                                                                                                                                                  
      *processes                                                                           * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                        final_chk_only_ind="0" and                                                                                                                                                                                     
                                        geo_edit_ind="0" and                                                                                                                                                                                           
                                        record_2_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit $200 ;                                                                                                                                                                                                                   
                  file "&jobpath/hmda_lar_edits.sas" ;                                                                                                                                                                                                          
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                        
                     put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                     put "if sys_suppressed_ind ne '1' and sys_next_year_ind ne '1' then do ; " ;                                                                                                                                                               
                     put "      if sys_geocoded_ind = '1' then do ; " ;                                                                                                                                                                                         
                     geoedit=trim ("&jobpath"!!'/hmda_lar_edits_geocoding.sas') ;  
                      
                     len=length(trim (geoedit)) ;                                                                                                                                                                                                                   
                     put '         %include "' geoedit $varying200. len '" ; ' ;                                                                                                                                                                                                   
                     put '      end ; ' ;                                                                                                                                                                                                                       
                  end ;  
                  
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                  
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                 
               if eof then do ;                                                                                                                                                                                                                                      
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                     put 'end ; ' ;                                                                                                                                                                                                                             
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA LAR Edits during any of the SAS/WA error      * ;                                                                                                                                                                  
      *correction load processes                                                           * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                        final_chk_only_ind="0" and                                                                                                                                                                                     
                                        geo_edit_ind="0" and                                                                                                                                                                                           
                                        record_2_ind="1" and                                                                                                                                                                                                       
                                        suppressable_ind='0'                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit qedit $200 ;                                                                                                                                                                                                             
                file "&jobpath/hmda_lar_correction_edits.sas" ;                                                                                                                                                                                                 
                if _n_ =1 then do ;                                                                                                                                                                                                                             
                   put 'data &ds ; ' ;                                                                                                                                                                                                                          
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                   put "if sys_suppressed_ind ne '1' and sys_next_year_ind ne '1' then do ; " ;                                                                                                                                                                 
                   put "      if sys_geocoded_ind = '1' then do ; " ;                                                                                                                                                                                           
                   geoedit=compress ("&jobpath"!!'/hmda_lar_edits_geocoding.sas') ;                                                                                                                                                                             
                   geoedit=trim (geoedit) ;                                                                                                                                                                                                                     
                   put '         %include "' geoedit '" ; ' ;                                                                                                                                                                                                     
                   put '      end ; ' ;                                                                                                                                                                                                                         
                   put 'if allq = " " then do ; ' ;                                                                                                                                                                                                             
                   %do x=1 %to &nQEdits ;                                                                                                                                                                                                                       
                       %if &&qedit&x ne ALLQ %then %do ;                                                                                                                                                                                                        
                         put '      if ' "&&qedit&x" ' eq " " then do ; ' ;                                                                                                                                                                                     
                         qedit=compress ("&jobpath"!!'/'!!"H_&&qedit&x"!!'.sas') ;                                                                                                                                                                                
                         qedit=trim (qedit) ;                                                                                                                                                                                                                   
                         put '         %include "' qedit '" ; ' ;                                                                                                                                                                                                 
                         put '      end ; ' ;                                                                                                                                                                                                                   
                        %end ;                                                                                                                                                                                                                                  
                    %end ;                                                                                                                                                                                                                                      
                    put '    end ; ' ;                                                                                                                                                                                                                          
                end ;                                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                     
                                                                                                                                                                                                                      
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                                                                                 
                                                                                                                                                                                                                                                                
                if eof then do ;                                                                                                                                                                                                                                
                   put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                      
                   put 'end ; ' ;                                                                                                                                                                                                                               
                   put 'run ; ' ;                                                                                                                                                                                                                               
                end ;                                                                                                                                                                                                                                           
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA  (geocode related) Transmittal Edits during   * ;                                                                                                                                                                  
      *interaction via the HMDA Submission UI                                              * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
                                                                                                                                                                                                                                                                
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                               
                                        active_ind="1" and                                                                                                                                                                                                         
                                        final_chk_only_ind="0" and                                                                                                                                                                                     
                                        geo_edit_ind="1" and                                                                                                                                                                                           
                                        record_1_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/hmda_transmittal_edits_geocoding.sas" ;                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                   
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                 
                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA  (geocode related LAR Edits) during any of the* ;                                                                                                                                                                  
      *SAS/WA load/update processes                                                        * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
                                                                                                                                                                                                                                                                
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                                                                                                                                                                                                               
                                        active_ind="1" and                                                                                                                                                                                                         
                                        final_chk_only_ind="0" and                                                                                                                                                                                     
                                        geo_edit_ind="1" and                                                                                                                                                                                           
                                        record_2_ind="1"                                                                                                                                                                                                           
                                        )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                  length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/hmda_lar_edits_geocoding.sas" ;                                                                                                                                                                                                
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                   
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                  put statement;     
                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                
            run ;     

      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply HMDA macro level edits                             * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
                                                                                                
                                                                                                                                                                                                                                                                 
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                     
                                        macro_level_ind='1' and                                                                                                                                                                                       
                                        active_ind="1"                                                                                                                                                                                                            
                                        ))                                                                                                                                                                                                                          
                              end = eof ;                                                                                                                                                                                                                     
                  length sascode $200 ;
                  file "&jobpath/hmdamacroedit.sas" ;  

                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                          
                     put 'set &ds ; ' ;                                                                                                                                                                                                                           
                  end ;  
                                    
                  sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                  
                                    
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;                                                                                                                                                                                                                                                                      
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                                                                                                                                                                                      
                      put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;      

                                                                                                                                     
             run;                                                                                                                                        
   

 
                                                                                                                                                                                                                                                                
      %end ;                                                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                
      %else                                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                
      %if &HMDA_or_CRA = CRA %then %do ;                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Transmittal Edits during the final edit check  * ;                                                                                                                                                                  
      *before the submission file is generated                                             * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
                                                                                                                                                                                                                                                                
                 data _null_;                                                                                                                                                                                                                                   
                        set &editsds (where=(    HMDA_or_CRA        = "C"                                                                                                                                                                            
                                             and active_ind         = "1"                                                                                                                                                                                       
                                          /* and final_chk_only_ind = "1" and */                                                                                                                                                                                
                                             and record_3_ind       = "1"                                                                                                                                                                                       
                                           )                                                                                                                                                                                                                    
                                    ) end = eof ;                                                                                                                                                                                                               
                      length sascode $200 ;                                                                                                                                                                                                                     
                      file "&jobpath/final_cra_transmittal_edits.sas" ;                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                      %* sashole 2003-03-10: added end=EOF option to set &ds below ;                                                                                                                                                                            
                      %* this is needed to handle CRA S010 per talk with MAT       ;                                                                                                                                                                            
                                                                                                                                                                                                                                                                
                      if _n_ = 1 then do ;                                                                                                                                                                                                                      
                         put 'data &ds ;'  ;                                                                                                                                                                                                                    
                         put '   set &ds end = EOF ;' ;                                                                                                                                                                                                         
                      end ;                                                                                                                                                                                                                                     

                      if _is_custom then                                                                                                                                                                                                                                              
                         sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                      else
                         sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  
                     year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                     statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                     put statement;     
                                
                   
                                                                                                                                                                                                                                                                
                      if eof then do ;                                                                                                                                                                                                                          
                         put '   if sys_error_editkeys ne ""  then sys_error_datetime = &dtstamp;' ;                                                                                                                                                            
                         put 'run ;' ;                                                                                                                                                                                                                          
                      end ;                                                                                                                                                                                                                                     
                  run ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Microdata Edits during the final edit check    * ;                                                                                                                                                                  
      *before the submission file is generated                                             * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
                                                                                                                                                                                                                                                                
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                                 /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                        record_9_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_cra_microdata_edits.sas" ;                                                                                                                                                                                               
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                if _is_custom then                                                                                                                                                                                                                                              
                   sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                else
                   sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                put statement;     
                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                
                if eof then do ;                                                                                                                                                                                                                              
                   put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                   put 'run ; ' ;                                                                                                                                                                                                                                   
                end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Small Business and Farm Edits during the final * ;                                                                                                                                                                  
      *edit check before the submission file is generated                                  * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                      (record_4_ind="1" or record_5_ind="1")                                                                                                                                                                                    
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_cra_smallbizfarm_edits.sas" ;                                                                                                                                                                                            
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                 if _is_custom then                                                                                                                                                                                                                                              
                    sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                 else
                    sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Comm Dev Edits during the final edit           * ;                                                                                                                                                                  
      *check before the submission file is generated                                       * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                     record_6_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_cra_commdev_edits.sas" ;                                                                                                                                                                                                 
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                if _is_custom then                                                                                                                                                                                                                                              
                   sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                else
                   sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;
 
                year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                
                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                
                if eof then do ;                                                                                                                                                                                                                              
                   put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                   put 'run ; ' ;                                                                                                                                                                                                                                   
                end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA 3rd Party Edits during the final edit          * ;                                                                                                                                                                  
      *check before the submission file is generated                                       * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                     record_7_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_cra_3rdparty_edits.sas" ;                                                                                                                                                                                                
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                 if _is_custom then                                                                                                                                                                                                                                              
                    sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                 else
                    sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                 year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                
                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA AA Edits during the final edit                 * ;                                                                                                                                                                  
      *check before the submission file is generated                                       * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 /* final_chk_only_ind="1" and */                                                                                                                                                                               
                                     record_8_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/final_cra_aa_edits.sas" ;                                                                                                                                                                                                      
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds ; ' ;                                                                                                                                                                                                                          
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ; 
 
                   year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                   statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                 
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Microdata Edits during any of the SAS/WA       * ;                                                                                                                                                                  
      *load/updateprocesses                                                                * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                 geo_edit_ind="0" and                                                                                                                                                                                                           
                                     record_9_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit $200 ;                                                                                                                                                                                                                   
                  file "&jobpath/cra_microdata_edits.sas" ;                                                                                                                                                                                                     
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                        
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                     put "if sys_suppressed_ind ne '1' and sys_next_year_ind ne '1' then do ; " ;                                                                                                                                                               
                     put "      if sys_geocoded_ind = '1' then do ; " ;                                                                                                                                                                                         
                     geoedit=compress ("&jobpath"!!'/cra_microdata_edits_geocoding.sas') ;                                                                                                                                                                      
                     geoedit=trim (geoedit) ; 
                     len=length(trim (geoedit)) ;                                                                                                                                                                                                                   
                     put '         %include "' geoedit $varying200. len '" ; ' ;                                                                                                                                                                                                
                     put '      end ; ' ;                                                                                                                                                                                                                       
                   end ;                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                   year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                   statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                
                                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                     put 'end ; ' ;                                                                                                                                                                                                                             
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Microdata Edits during any of the SAS/WA       * ;                                                                                                                                                                  
      *error correction update processes                                                   * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                 geo_edit_ind="0" and                                                                                                                                                                                                           
                                     record_9_ind="1" and                                                                                                                                                                                                       
                                 suppressable_ind ='0'                                                                                                                                                                                                          
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit qedit $200 ;                                                                                                                                                                                                             
                  file "&jobpath/cra_microdata_correction_edits.sas" ;                                                                                                                                                                                          
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                        
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                     put "if sys_suppressed_ind ne '1' and sys_next_year_ind ne '1' then do ; " ;                                                                                                                                                               
                     put "      if sys_geocoded_ind = '1' then do ; " ;                                                                                                                                                                                         
                     geoedit=compress ("&jobpath"!!'/cra_microdata_edits_geocoding.sas') ;                                                                                                                                                                      
                     geoedit=trim (geoedit) ;                                                                                                                                                                                                                   
                     put '         %include "' geoedit '" ; ' ;                                                                                                                                                                                                   
                     put '      end ; ' ;                                                                                                                                                                                                                       
                     put 'if allq = " " then do ; ' ;                                                                                                                                                                                                           
                      %do x=1 %to &nQEdits ;                                                                                                                                                                                                                    
                           %if &&qedit&x ne ALLQ %then %do ;                                                                                                                                                                                                    
                           put '      if ' "&&qedit&x" ' eq " " then do ; ' ;                                                                                                                                                                                   
                           qedit=compress ("&jobpath"!!'/'!!"C_&&qedit&x"!!'.sas') ;                                                                                                                                                                              
                           qedit=trim (qedit) ;                                                                                                                                                                                                                 
                           put '         %include "' qedit '" ; ' ;                                                                                                                                                                                               
                           put '      end ; ' ;                                                                                                                                                                                                                 
                           %end ;                                                                                                                                                                                                                               
                     %end ;                                                                                                                                                                                                                                     
                     put 'end ; ' ;                                                                                                                                                                                                                             
                  end ;     
                  
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  
                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                
                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                     put 'end ; ' ;                                                                                                                                                                                                                             
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA  (geocode related) Microdata Edits during any of* ;                                                                                                                                                                 
      *the SAS/WA load/updateprocesses                                                     * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                 geo_edit_ind="1" and                                                                                                                                                                                                           
                                     record_9_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/cra_microdata_edits_geocoding.sas" ; 
                  
                if _is_custom then                                                                                                                                                                                                                                              
                   sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                else
                   sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Small Business and Farm Edits during any of the* ;                                                                                                                                                                  
      *SAS/WA aggregate load/updateprocesses                                               * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                         active_ind="1" and                                                                                                                                                                                                         
                                         final_chk_only_ind="0" and                                                                                                                                                                                     
                                         geo_edit_ind="0" and                                                                                                                                                                                           
                                        (record_4_ind="1" or record_5_ind="1")                                                                                                                                                                                    
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit $200 ;                                                                                                                                                                                                                   
                  file "&jobpath/cra_comp_smallbizfarm_edits.sas" ;                                                                                                                                                                                             
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                        
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                     put "if county_code ne "" and state_code ne "" and MA ne "" and census_tract ne "" then do ; " ;                                                                                                                                           
                     geoedit=compress ("&jobpath"!!'/cra_comp_smallbizfarm_edits_geocoding.sas') ;                                                                                                                                                              
                     geoedit=trim (geoedit) ;                                                                                                                                                                                                                   
                     put '   %include "' geoedit '" ; ' ;                                                                                                                                                                                                         
                     put ' end ; ' ;                                                                                                                                                                                                                            
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      *************************************************************************************** ;                                                                                                                                                                 
      *generate program that will apply CRA Small  (geocode related) Business and Farm Edits* ;                                                                                                                                                                 
      *during any of the SAS/WA aggregate load/updateprocesses                              * ;                                                                                                                                                                 
      *************************************************************************************** ;                                                                                                                                                                 
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                                 geo_edit_ind="1" and                                                                                                                                                                                           
                                      (record_4_ind="1" or record_5_ind="1")                                                                                                                                                                                    
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/cra_comp_smallbizfarm_edits_geocoding.sas" ;                                                                                                                                                                                   
                                                                                                                                                                                                                                                                
                if _is_custom then                                                                                                                                                                                                                                              
                   sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                else
                   sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

               year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                          
                                                                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA Comm Dev Edits during any of the SAS/WA        * ;                                                                                                                                                                  
      *aggregate load/updateprocesses                                                      * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                     record_6_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/cra_commdev_edits.sas" ;                                                                                                                                                                                                       
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds  ; ' ;                                                                                                                                                                                                                         
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                   year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                        

                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA 3rd Party Edits during any of the SAS/WA       * ;                                                                                                                                                                  
      *aggregate load/updateprocesses                                                      * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                     final_chk_only_ind="0" and                                                                                                                                                                                     
                                     record_7_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/cra_3rdparty_edits.sas" ;                                                                                                                                                                                                      
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                   put 'data &ds ; ' ;                                                                                                                                                                                                                          
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                   if _is_custom then                                                                                                                                                                                                                                              
                      sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                   else
                      sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                   year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne ""  then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                   
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA AA Edits during any of the SAS/WA              * ;                                                                                                                                                                  
      *aggregate load/updateprocesses                                                      * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                                
                                        active_ind="1" and                                                                                                                                                                                                         
                                        final_chk_only_ind="0" and                                                                                                                                                                                     
                                        geo_edit_ind="0" and                                                                                                                                                                                           
                                        record_8_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode geoedit $200 ;                                                                                                                                                                                                                   
                  file "&jobpath/cra_aa_edits.sas" ;                                                                                                                                                                                                            
                  if _n_ =1 then do ;                                                                                                                                                                                                                           
                     put 'data &ds ; ' ;                                                                                                                                                                                                                        
                   put 'set &ds ; ' ;                                                                                                                                                                                                                           
                                                                                                                                                                                                                                                                
                     put "if county_code ne "" and state_code ne "" and MA ne "" and census_tract ne "" then do ; " ;                                                                                                                                           
                     geoedit=compress ("&jobpath"!!'/cra_aa_edits_geocoding.sas') ;                                                                                                                                                                             
                     geoedit=trim (geoedit) ;                                                                                                                                                                                                                   
                     put '   %include "' geoedit '" ; ' ;                                                                                                                                                                                                         
                     put ' end ; ' ;                                                                                                                                                                                                                            
                  end ;                                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                  year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                
                  if eof then do ;                                                                                                                                                                                                                              
                     put 'if sys_error_editkeys ne "" then sys_error_datetime=&dtstamp ; ' ;                                                                                                                                                                    
                     put 'run ; ' ;                                                                                                                                                                                                                                   
                  end ;                                                                                                                                                                                                                                         
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      ************************************************************************************** ;                                                                                                                                                                  
      *generate program that will apply CRA (geocode related) AA Edits during any of the    * ;                                                                                                                                                                 
      *SAS/WA aggregate load/updateprocesses                                               * ;                                                                                                                                                                  
      ************************************************************************************** ;                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
                  set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                     
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                                 final_chk_only_ind="0" and                                                                                                                                                                                     
                                                 geo_edit_ind="1" and                                                                                                                                                                                           
                                     record_8_ind="1"                                                                                                                                                                                                           
                                     )                                                                                                                                                                                                                          
                              ) end = eof ;                                                                                                                                                                                                                     
                length sascode $200 ;                                                                                                                                                                                                                           
                  file "&jobpath/cra_aa_edits_geocoding.sas" ;                                                                                                                                                                                                  
                                                                                                                                                                                                                                                                
                  if _is_custom then                                                                                                                                                                                                                                              
                     sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
                  else
                     sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  

                 year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                                            
            run ;                                                                                                                                                                                                                                               
                                                                                                                                                                                                                                                                
      %end ;                                                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                
   %mend generateEditCode ;                                                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                
   %macro generateQualityEdits (HMDA_or_CRA , editsds) ;                                                                                                                                                                                                        
      %************************************************************************************** ;                                                                                                                                                                 
      %*generate program that will apply HMDA Quality Edits during any of the SAS/WA        * ;                                                                                                                                                                 
      %*load/update processes                                                               * ;                                                                                                                                                                 
      %************************************************************************************** ;                                                                                                                                                                 
      %do x=1 %to &nQEdits ;                                                                                                                                                                                                                                    
         %if &HMDA_or_CRA = HMDA %then                                                                                                                                                                                                                          
         %do ;                                                                                                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
               set &editsds (where= (HMDA_or_CRA="H" and                                                                                                                                                                                                        
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                     final_chk_only_ind="0" and                                                                                                                                                                                                 
                                     edit_id="&&qedit&x" and                                                                                                                                                                                                    
                                     record_2_ind="1"                                                                                                                                                                                                           
                                             )                                                                                                                                                                                                                  
                                      )  end = eof ;                                                                                                                                                                                                            
               length sascode $200 ;                                                                                                                                                                                                                           
               file "&jobpath/%str (H_&&qedit&x).sas" ;  
                
               if _is_custom then                                                                                                                                                                                                                                              
                  sascode=trim("&c_hmdaedit")!!'/'!!trim(program_name)!!'.sas' ; 
               else
                  sascode=trim("&hmdaedit")!!'/'!!trim(program_name)!!'.sas' ;  
                year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                                                                                                                                                                                                              
            run ;                                                                                                                                                                                                                                               
         %end ;                                                                                                                                                                                                                                                 
                                                                                                                                                                                                                                                                
         %else %if &HMDA_or_CRA = CRA %then                                                                                                                                                                                                                     
         %do ;                                                                                                                                                                                                                                                  
            data _null_ ;                                                                                                                                                                                                                                       
               set &editsds (where= (HMDA_or_CRA="C" and                                                                                                                                                                                                        
                                                                                                                                                                                                                             
                                     active_ind="1" and                                                                                                                                                                                                         
                                     final_chk_only_ind="0" and                                                                                                                                                                                                 
                                     edit_id="&&qedit&x" and                                                                                                                                                                                                    
                                     record_9_ind="1"                                                                                                                                                                                                           
                               )                                                                                                                                                                                                                                
                        ) end = eof ;                                                                                                                                                                                                                           
               length sascode $200 ;                                                                                                                                                                                                                            
               file "&jobpath/%str (C_&&qedit&x).sas" ;                                                                                                                                                                                                           
               if _is_custom then                                                                                                                                                                                                                                              
                  sascode=trim("&c_craedit")!!'/'!!trim(program_name)!!'.sas' ; 
               else
                  sascode=trim("&craedit")!!'/'!!trim(program_name)!!'.sas' ;  
                year_condition= put(start_year,4.)|| ' <= activity_year <= '||put(end_year,4.);
                  statement='if '||trim(year_condition)||' then %include"'||trim(sascode)||'";' ;
                                                                                                                                                                                                                       
                   put statement;     
                                
                                                                                                                                                                                                                                 
            run ;                                                                                                                                                                                                                                               
         %end ;                                                                                                                                                                                                                                                 
      %end ;                                                                                                                                                                                                                                                    
   %mEnd generateQualityEdits ;        


   ***************************************************************************** ;
   *****  sort l_sys.L_validation_reason by edit_id                            * ;
   ***************************************************************************** ;
   
   proc sort data=l_sys.l_validation_reason force;
       by hmda_or_cra edit_id reason_code;
   run;

   proc datasets lib=l_sys nolist;
     modify L_VALIDATION_REASON;
     index create reason_key
      / UNIQUE ;
     index create xnkvalrsn = ( reason_code hmda_or_cra edit_id )
      / UNIQUE;
   quit;

 
   
 
 
                                                                                                                                                                                                                                                                
   ***************************************************************************** ;                                                                                                                                                                              
   ***** (Only used to generate HMDA LAR & CRA Microdata Correction Edits) ***** ;                                                                                                                                                                              
   ********************** Determine If Quality is suppressable ***************** ;                                                                                                                                                                              
   ***************************************************************************** ;                                                                                                                                                                              
                                                                                                                                                                                                                                                                
   proc sort data=l_sys.l_validation_reason out=l_validation_reason nodupkey ;                                                                                                                                                                                  
             by hmda_or_cra edit_id ;                                                                                                                                                                                                                           
   run ;                                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
   proc sort data=l_sys.l_edit out=l_edit nodupkey noequals;                                                                                                                                                                                                            
      by hmda_or_cra edit_id ;                                                                                                                                                                                                                                  
   run ;                                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
   proc sort data=l_sys.l_custom_edit
             out=l_custom_edit nodupkey noequals;   
             
             by hmda_or_cra edit_id ;                                                                                                                                                                                                                           
   run ;                                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
   %*Custom Edits UI integration ; 
   DATA l_edit;
     set l_edit
         l_custom_edit(in=in2);
     _is_custom=in2;
     by hmda_or_cra edit_id;
     if _is_custom then program_name=upcase(program_name);
     else program_name=lowcase(program_name);
   run;
     

  
   proc sort data=l_edit out=l_edit nodupkey noequals;                                                                                                                                                                                                                  
      by hmda_or_cra edit_id ;                                                                                                                                                                                                                                  
   run ;                                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
   data l_edit ;                                                                                                                                                                                                                                                
      merge l_edit               (in=a                         )                                                                                                                                                                                                
            l_validation_reason  (in=b keep=hmda_or_cra edit_id)                                                                                                                                                                                                
      ;                                                                                                                                                                                                                                                         
      by hmda_or_cra edit_id ;                                                                                                                                                                                                                                  
      if a ;                                                                                                                                                                                                                                                    
      if b then suppressable_ind = '1' ;                                                                                                                                                                                                                        
      else      suppressable_ind = '0' ;                                                                                                                                                                                                                        
   run ;                                                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
                                                                                                                                                                                                                                                                
   **************************************************************************** ;                                                                                                                                                                               
   *********************** Build HMDA Edit Engine  **************************** ;                                                                                                                                                                               
   **************************************************************************** ;                                                                                                                                                                               
                                                                                                                                                                                                                                                                
   %*create macro list of suppressable HMDA Quality edits ;                                                                                                                                                                                                     
                                                                                                                                                                                                                                                                
   %let nQEdits=0 ;                                                                                                                                                                                                                                             
                                                                                                                                                                                                                                                                
   data _null_ ;                                                                                                                                                                                                                                                
      set l_validation_reason (where= (HMDA_or_CRA="H"))  end = lr ;                                                                                                                                                                                            
      cnt + 1 ;                                                                                                                                                                                                                                                 
      ccnt = left (put (cnt,4.)) ;                                                                                                                                                                                                                              
      call symput ('qedit'||ccnt,trim (left (edit_id))) ;                                                                                                                                                                                                       
      if lr then call symput ('nQEdits',ccnt) ;                                                                                                                                                                                                                 
    run ;                                                                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
   %*call macros that build engine ;     
                                                                                                                                                                                                                                                                
   %generateEditCode (HMDA,L_EDIT) ;                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                
   %generateQualityEdits (HMDA,L_EDIT) ;                                                                                                                                                                                                                        
                                                                                                                                                                                                                                                                
   **************************************************************************** ;                                                                                                                                                                               
   *********************** Build CRA Edit Engine  ***************************** ;                                                                                                                                                                               
   **************************************************************************** ;                                                                                                                                                                               
                                                                                                                                                                                                                                                                
  %*create macro list of suppressable CRA Quality edits ;                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
   %let nQEdits=0 ;                                                                                                                                                                                                                                             
                                                                                                                                                                                                                                                                
   data _null_ ;                                                                                                                                                                                                                                                
      set l_validation_reason (where= (HMDA_or_CRA="C"))  end = lr ;                                                                                                                                                                                            
      cnt + 1 ;                                                                                                                                                                                                                                                 
      ccnt = left (put (cnt,4.)) ;                                                                                                                                                                                                                              
      call symput ('qedit'||ccnt,trim (left (edit_id))) ;                                                                                                                                                                                                       
      if lr then call symput ('nQEdits',ccnt) ;                                                                                                                                                                                                                 
    run ;                                                                                                                                                                                                                                                       
                                                                                                                                                                                                                                                                
   %*call macros that build engine ;                                                                                                                                                                                                                            
                                                                                                                                                                                                                                                                
   %generateEditCode (CRA,L_EDIT) ;                                                                                                                                                                                                                             
                                                                                                                                                                                                                
                                                                                                                                                                                                                                                                
   %generateQualityEdits (CRA,L_EDIT) ;                                                                                                                                                                                                                         
                                                                                                                                                                                                                                                                
  
   %put NOTE: {END: BUILD_EDIT_ENGINE};                                                                                                                                                                                                                                                                
%mEnd build_edit_engine ;                                                                                                                                                                                                                                       
